/*
 * Copyright (c) 1996 Barton P. Miller
 * 
 * We provide the Paradyn Parallel Performance Tools (below
 * described as Paradyn") on an AS IS basis, and do not warrant its
 * validity or performance.  We reserve the right to update, modify,
 * or discontinue this software at any time.  We shall have no
 * obligation to supply such updates or modifications or any other
 * form of support to you.
 * 
 * This license is for research uses.  For such uses, there is no
 * charge. We define "research use" to mean you may freely use it
 * inside your organization for whatever purposes you see fit. But you
 * may not re-distribute Paradyn or parts of Paradyn, in any form
 * source or binary (including derivatives), electronic or otherwise,
 * to any other organization or entity without our permission.
 * 
 * (for other uses, please contact us at paradyn@cs.wisc.edu)
 * 
 * All warranties, including without limitation, any warranty of
 * merchantability or fitness for a particular purpose, are hereby
 * excluded.
 * 
 * By your use of Paradyn, you understand and agree that we (or any
 * other person or entity with proprietary rights in Paradyn) are
 * under no obligation to provide either maintenance services,
 * update services, notices of latent defects, or correction of
 * defects for Paradyn.
 * 
 * Even if advised of the possibility of such damages, under no
 * circumstances shall we (or any other person or entity with
 * proprietary rights in the software licensed hereunder) be liable
 * to you or any third party for direct, indirect, or consequential
 * damages of any character regardless of type of action, including,
 * without limitation, loss of profits, loss of use, loss of good
 * will, or computer failure or malfunction.  You agree to indemnify
 * us (and any other person or entity with proprietary rights in the
 * software licensed hereunder) for any and all liability it may
 * incur to third parties resulting from your use of Paradyn.
 */





/************************************************************************
 * globals.c: variables shared within libthread.
************************************************************************/





/************************************************************************
 * header files.
************************************************************************/
#include "threadP.h"





/************************************************************************
 * globals.
************************************************************************/

unsigned  thr_trace_flag        = 0;
FILE*     thr_trace_fp;

#if defined(ENABLE_PREEMPTION)
unsigned  thr_inlib             = 0;
unsigned  thr_quantum           = 1000;
#endif /* defined(ENABLE_PREEMPTION) */

unsigned  thr_init_done         = 0;
unsigned  thr_pid               = 0;

ThrTable*	thr_tab				= NULL;

Queue     thr_ready_q;
Queue     thr_zombie_q          = 0;
Queue     thr_waiter_q          = 0;
Thread    thr_curr              = 0;

unsigned   thr_curr_key         = 0;
Destructor thr_key_destructors[THR_KEY_TABLE_SIZE];

WaitSet		thr_all_waitset;
thread_t	thr_last			= 1;

const char* thr_errlst[]        = {
    "no error",
    "generic libthread error",
    "memory allocation failed",
    "call will deadlock",
    "invalid tid for the call",
    "invalid key for the call",
    "invalid fd for the call",
    "invalid `will_block' function for the call",
    "invalid message send tag",
    "invalid signal number for the call",
    "no message waiting",
};
const unsigned thr_nerr         =
    ((sizeof thr_errlst)/sizeof(char *));
